/*
 * @(#)src/demo/rmi-iiop/hello/RemoteHelloApplication.java, ds131, ds131, 20011204 1.2.2.3
 * ===========================================================================
 * Licensed Materials - Property of IBM
 * "Restricted Materials of IBM"
 *
 * IBM Java(tm)2 SDK, Standard Edition, v 1.3.1
 * Copyright IBM Corp. 1998 1999 
 * ===========================================================================
 */

/* @(#)RemoteHelloApplication.java	1.5 99/06/07 */
/*
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

/*
 * RMI-IIOP v1.0
 *
 */


package hello;

import java.rmi.RemoteException;
import java.util.Properties;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import java.rmi.RMISecurityManager;

public class RemoteHelloApplication
{
    public void run (String[] args)
    {
	// Must pass the server's host address as a command line parameter

	String host = args[0];

	// Pass system properties with -D option of java command, e.g.
	// for jrmp ...
	// -Djava.naming.factory.initial=com.sun.jndi.registry.RegistryContextFactory
	// for iiop ...
	// -Djava.naming.factory.initial=com.sun.jndi.cosnaming.CNCtxFactory

	String factory = System.getProperty ("java.naming.factory.initial");

	try
	    {
		String hostName = args[0];

		if ( System.getSecurityManager() == null ) {
		    System.setSecurityManager (new RMISecurityManager());
		}

		Properties env = new Properties ();

		// Shouldn't have to do this, but for now you must

		if ( factory.equals ("com.sun.jndi.cosnaming.CNCtxFactory") ) {
		    env.put ("java.naming.provider.url", "iiop://" + host);
		} else {
		    env.put ("java.naming.provider.url", "rmi://" + host);
		}

		InitialContext context = new InitialContext (env);
		Object o = context.lookup ("RemoteHelloServer");
		RemoteHello hello = (RemoteHello)PortableRemoteObject.narrow (o,RemoteHello.class);

		System.out.println (hello.message());
	    }
	catch (Exception e)
	    {
		System.out.println ("exception: " + e.getMessage ());
		e.printStackTrace ();
	    }

    }

    public static void main (String[] args)
    {
	RemoteHelloApplication app = new RemoteHelloApplication ();
	app.run (args);
    }

}
